#include <CoreFoundation/CoreFoundation.h>
#include <Security/Security.h>
#include <CoreServices/CoreServices.h>

int main (int argc, const char * argv[]) {
    OSStatus status;
    OSStatus status1;
    
    void * myPassword = "myP4sSw0rD";
    UInt32 myPasswordLength = strlen(myPassword);
    
    void * thePassword = nil;
    UInt32 thePasswordLength = 0;
    
    SecKeychainItemRef itemRef = nil;
    
    // Ignoring obligation to manage memory, to clarify the point of the report.
    
    /////////////////////////////////////////////////////////////////
    //
    // Setup: make sure password is on the keychain
    //
    ////////////////////////////////////////////////////////////////
    
    status1 = SecKeychainFindGenericPassword (
                                              NULL,           // default keychain
                                              10,             // length of service name
                                              "SurfWriter",   // service name
                                              10,             // length of account name
                                              "MyUserAcct",   // account name
                                              &thePasswordLength,  // length of password
                                              &thePassword,   // pointer to password data
                                              &itemRef         // the item reference
                                              );
   if (status1 == errSecItemNotFound) { //Is password on keychain?
        status = SecKeychainAddGenericPassword (
                                                             NULL,            // default keychain
                                                             10,              // length of service name
                                                             "SurfWriter",    // service name
                                                             10,              // length of account name
                                                             "MyUserAcct",    // account name
                                                             myPasswordLength,  // length of password
                                                             myPassword,        // pointer to password data
                                                             NULL             // the item reference
                                                             );
    }
    /////////////////////////////////////////////////////////////////
    //
    // Control: confirm that the password is retrievable normally
    //
    ////////////////////////////////////////////////////////////////
    status1 = SecKeychainFindGenericPassword (
                                              NULL,           // default keychain
                                              10,             // length of service name
                                              "SurfWriter",   // service name
                                              10,             // length of account name
                                              "MyUserAcct",   // account name
                                              &thePasswordLength,  // length of password
                                              &thePassword,   // pointer to password data
                                              &itemRef         // the item reference
                                              );
    
    if (status1 == noErr) {
        printf("Control pass: received password %s\n", thePassword);
    }
    else {
        printf("Control ERROR: can't retrieve password!\n");
        return (status1);
    }
    

    /////////////////////////////////////////////////////////////////
    //
    // Test case: demonstrate that the password can't be retrieved if !UserInteractionAllowed
    //
    ////////////////////////////////////////////////////////////////
    SecKeychainSetUserInteractionAllowed(FALSE);
    
    status1 = SecKeychainFindGenericPassword (
                                              NULL,           // default keychain
                                              10,             // length of service name
                                              "SurfWriter",   // service name
                                              10,             // length of account name
                                              "MyUserAcct",   // account name
                                              &thePasswordLength,  // length of password
                                              &thePassword,   // pointer to password data
                                              &itemRef         // the item reference
                                              );
    
    if (status1 == noErr) {
        printf("Test pass: received password %s\n", thePassword);
    }
    else {
        printf("Test ERROR: can't retrieve password! (status: %d)\n", status1);
        return (status1);
    }
    
    
    
    return (status);
    
}